# Numerik Vorkurs
# Blatt 4 Aufgabe 2
# Christian Power 11.10.2016

"""
γ(t, anzahl_wind) R -> R^3 ist ein Spiralkurve, die nach oben geht. 
`anzahl_wind` ist ein optionales Argument, dass bei leerer Eingabe den 
Werte `= 1` annimmt. 
"""
γ(t, anzahl_wind::Int = 1) = (cos(anzahl_wind*t),sin(anzahl_wind*t),t)

"""
Erstelle gewünschte Plots.

- **Precondition**: using PyPlot
"""
function b4a2_plot()
    anzahl_umd = 1  # Ändere diesen Wert
    t = 0:.1/anzahl_umd:10
    (x,y,z) = γ(t,anzahl_umd)
    axes(projection="3d")
    plot(x,y,z)
end

b4a2_plot()

# ----------------------------------------------------------------------
# Tests

"""
b4a2_test() testet γ
"""
function b4a2_test()
    toleranz = 1e-8
    norm_squ(x,y,z) = abs(x)^2 + abs(y)^2 + abs(z)^2
    (x,y,z) = γ(1.0)
    assert(abs(norm_squ(x,y,z) - 2) < toleranz)
    (x,y,z) = γ(3,3)
    assert(abs(norm_squ(x,y,z) - (1+9)) < toleranz)
end

b4a2_test()  # Lasse Tests laufen 
