"""
(ar,um) = area(a,b) 
Berechne *Flaeche* (ar) und *Umfang* (um).

- **Precondition**: Skalare a,b > 0
- **Postcondition**: Skalare ar, um > 0

# Beispiel
```julia
julia> area(1,1)
(1,4)
```
"""
function area(a, b)
    assert(a>0 && b>0)
    ar = a * b
    assert(ar>0)
    um = 2*a + 2*b
    assert(um>0)
    return (ar, um)
end
