# Blatt 3 Aufg. 4
workspace()
# using PyPlot
"""
b3a4fun(x) :R -> R mit drei 
Definitionsbereiche.  
Für x < 0 gilt f(x)=-x^2,
für 0 ≤ x ≤ 1 gilt f(x) = x 
und für 1 < x gilt f(x) = x^2 + 1
"""
function b3a4fun(x::Real)
    rv
    if x < 0
        rv = -x^2
    elseif x <= 1 # x >= 0 gilt autom.
        rv = x
    else # x > 1
        rv = x^2 + 1
    end
end # function
function b3a4fun(x::Array{Float64,1})
    rv = zeros(length(x))
    ind_set = x .< 0
    rv[ind_set] = -x[ind_set].^2
    ind_set = 0 .<= x .<= 1
    rv[ind_set] = x[ind_set]
    ind_set = x .> 1
    rv[ind_set] = x[ind_set].^2 + 1
    return rv
end # function
x = [a for a=-2:.0001:2] # 40001 elem
tic()
b3a4fun(x[:])
toc()
tic()
for elem in x
    b3a4fun(elem)
end
toc()
# plot(x,b3a4fun(x))
# title("Blatt 3 Aufg. 4")
# xlabel("\$-2\\leqq x \\leqq 2\$")
# ylabel("b3a4fun()")
# grid()
